]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Remove old cleanup code for `vcsh use`
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index 6fa6644aaed8b2462fe7070f53451ae12197675b..2c4e7267813d633be792714f761256696908a29e 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -6,7 +6,6 @@
 
 SELF=$(basename $0)
 
-
 help() {
        echo "usage: $SELF <args>
 
@@ -14,15 +13,17 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
-   exit                 Exit repository; unset ENV
+   enter                Enter repository; spawn new $SHELL
    init <repo>          Initialize a new repository
    list                 List all repositories
+   rename <repo> \\
+          <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
 
    seed-gitignore \\
    <repo>               Seed .gitignore.d/<repo> from git ls-files
-   use <repo>           Use repository; set ENV
+   setup                Set up repository with recommended settings
 
    <repo> <git command> Special command that allows you to run git commands
                         directly without having to type so much ;)" >&2
@@ -36,96 +37,20 @@ verbose() {
        if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-use() {
-       verbose "use() begin"
-       if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$VCSH_REPO_NAME" >&2
-               return 1
-       fi
-       export GIT_DIR
-       export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-       verbose "use() end"
+fatal() {
+       echo "$SELF: fatal: $1" >&2
+       exit $2
 }
 
-init() {
-       verbose "init() begin"
-       [ -e "$GIT_DIR" ] &&
-               echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
-       export GIT_WORK_TREE="$HOME"
-       mkdir -p "$GIT_WORK_TREE"
-       cd "$GIT_WORK_TREE" ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                return 1) || return $?
-       cd "$GIT_WORK_TREE"
-       git init
-       git config core.worktree     "$GIT_WORK_TREE"
-       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-       verbose "init() end"
+error() {
+       echo "$SELF: error: $1" >&2
 }
 
-leave() {
-       unset GIT_DIR
-       unset GIT_WORK_TREE
-       unset VCSH_DIRECTORY
+info() {
+       echo "$SELF: info: $1"
 }
 
-
-if [ "$1" = 'clone' ]; then
-       GIT_REMOTE="$2"
-       export GIT_REMOTE
-       VCSH_REPO_NAME="$3"
-       [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
-       export VCSH_REPO_NAME
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
-     [ "$1" = 'init' ] ||
-     [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ] ||
-     [ "$1" = 'use' ]; then
-       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
-       export VCSH_COMMAND="$1"
-       export VCSH_REPO_NAME="$2"
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       shift 2
-       export VCSH_EXTERNAL_COMMAND="$*"
-       if [ "$VCSH_COMMAND" = 'run' ]; then
-               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
-       fi
-elif [ "$1" = 'exit' ] ||
-     [ "$1" = 'help' ] ||
-     [ "$1" = 'list' ]; then
-       export VCSH_COMMAND="$1"
-else
-       [ -z $1 ] && help && return 0
-       export VCSH_COMMAND='run'
-       export VCSH_REPO_NAME="$1"
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       [ -d $GIT_DIR ] || (help && return 1) || return 0
-       shift 1
-       export VCSH_EXTERNAL_COMMAND="git $*"
-fi
-
-
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
-do
-       if [ ! -d "$check_directory" ]; then
-               if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       return 2
-               else
-                       echo "$SELF: info: attempting to create $check_directory"
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
-               fi
-       fi
-done
-
-
-if [ "$VCSH_COMMAND" = 'clone' ]; then
-       verbose "clone begin"
+clone() {
        init
        git remote add origin "$GIT_REMOTE"
        git config branch.master.remote origin
@@ -133,27 +58,20 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
        git fetch
        for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
                [ -e "$object" ] &&
-                       echo "$SELF: error: $object exists." &&
+                       error "'$object' exists." &&
                        VCSH_CONFLICT=1;
        done
        [ "$VCSH_CONFLICT" = '1' ] &&
-               echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-               echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               return 3
+               fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
        git merge origin/master
-#      use || return $?
-       verbose "clone end"
-
-#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
-elif [ "$VCSH_COMMAND" = 'help' ]; then
-       help
+}
 
-elif [ "$VCSH_COMMAND" = 'delete' ]; then
-       verbose "delete begin"
+delete() {
        old_dir="$PWD"
        cd "$HOME"
-       use || return $?
-       echo "$SELF: info: This operation WILL DETROY DATA!"
+       use
+       info "This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
 
@@ -162,53 +80,53 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || return 1
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
        for file in $files; do
-               rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+               rm -f $file || info "could not delete '$file', continuing with deletion"
        done
-       rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
+       rmdir "$GIT_DIR" || info "could not delete '$GIT_DIR'"
        cd "$old_dir"
-       verbose "delete end"
+}
+
+enter() {
+       use
+       $SHELL
+}
 
-elif [ "$VCSH_COMMAND" = 'exit' ]; then
-       verbose "exit begin"
-#      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-#              unset VCSH_NO_IGNORE_EOF
-#              setopt NO_IGNORE_EOF
-#      fi
-       leave
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "exit end"
-       return 0
+git_dir_exists() {
+       [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
+}
 
-elif [ "$VCSH_COMMAND" = 'init' ]; then
-       verbose "init begin"
-       init
-#      use || return $?
-       verbose "init end"
+init() {
+       [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+       export GIT_WORK_TREE="$HOME"
+       mkdir -p "$GIT_WORK_TREE"
+       cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+       git init
+       setup
+}
 
-elif [ "$VCSH_COMMAND" = 'list' ]; then
-       verbose "list begin"
+list() {
        for i in "$VCSH_BASE"/*.git; do
                echo $(basename "$i" .git)
        done
-       verbose "list end"
+}
+
+rename() {
+       git_dir_exists
+       [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+       mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
 
-elif [ "$VCSH_COMMAND" = 'run' ]; then
-       verbose "run begin"
-       use || return $?
+}
+
+run() {
+       use
        $VCSH_EXTERNAL_COMMAND
-       leave
-       verbose "run end"
+}
 
-elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
-       verbose "seed-gitignore begin"
-       use || return $?
-       # Switching directory as this has to be executed from $HOME to be of any use.
-       # Going back into old directory at the end in case `vcsh use` is reactivated.
-       old_dir="$PWD"
+seed_gitignore() {
+       use
        cd "$HOME"
-       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
        gitignores=$(for file in $(git ls-files); do
                while true; do
                        echo $file; new="${file%/*}"
@@ -216,8 +134,7 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                        file="$new"
                done;
        done | sort -u)
-       tempfile=$(mktemp) ||
-               (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
+       tempfile=$(mktemp) || fatal "could not create tempfile" 51
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
@@ -225,40 +142,80 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        done
        diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
                rm -f "$tempfile" &&
-               return
+               exit
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
-               echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
+               info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
-                        return 1) || return $?
+                       fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
-       cd "$old_dir"
-       verbose "seed-gitignore end"
+               fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
+}
 
-elif [ "$VCSH_COMMAND" = 'use' ]; then
-       verbose "use begin"
-#      if [ -n "$ZSH_VERSION" ]; then
-#              if [ -o NO_IGNORE_EOF ]; then
-#                      export VCSH_NO_IGNORE_EOF=1
-#                      setopt IGNORE_EOF
-#              fi
-#              vcsh_exit() {
-#                      vcsh exit;
-#                      zle reset-prompt;
-#              }
-#              zle -N vcsh_exit
-#              bindkey '^d' 'vcsh_exit'
-#      fi
-       use || return $?
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "use end"
+setup() {
+       use
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       git config vcsh.vcsh         'true'
+       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
 
-else
-       verbose "defaulting to calling help()"
-       help
-       echo "$SELF: fatal: You should never reach this code. File a bug, please."
-       return 99
+use() {
+       git_dir_exists
+       export GIT_WORK_TREE="$(git config --get core.worktree)"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
 
+if [ "$1" = 'clone' ]; then
+       [ -z $2 ] && fatal "$1: please specify a remote" 1
+       export VCSH_COMMAND="$1"
+       GIT_REMOTE="$2"
+       [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+       export VCSH_REPO_NAME
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'rename' ] ||
+     [ "$1" = 'run' ] ||
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'setup' ]; then
+       [ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
+       [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
+       [ "$1" = 'run' -a -z "$3" ]    && fatal "$1: please specify a command" 1
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ "$VCSH_COMMAND" = 'rename' ]         && export GIT_DIR_NEW="$VCSH_BASE/$3.git"
+       [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
+       [ "$VCSH_COMMAND" = 'seed-gitignore' ] && export VCSH_COMMAND='seed_gitignore'
+elif [ "$1" = 'list' ]; then
+       export VCSH_COMMAND="$1"
+elif [ -n "$1" ]; then
+       export VCSH_COMMAND=run
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || { help; exit 1; }
+       shift 1
+       export VCSH_EXTERNAL_COMMAND="git $*"
+else
+       # $1 is empty, or 'help'
+       help && exit
 fi
+
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       fatal "'$check_directory' exists but is not a directory" 13
+               else
+                       info "attempting to create '$check_directory'"
+                       mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+               fi
+       fi
+done
+
+verbose "$VCSH_COMMAND begin"
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"